wxWidgets: wxToolBar Class Reference

| Version: 3.1.5

Public Member Functions | List of all members
wxToolBar Class Reference
Class List by Category » Miscellaneous Windows

`#include </home/Hamis/wxwidgets-3.1/wxWidgets3.1-3.1.5-1.i686/src/wxWidgets-3.1.5/interface/wx/toolbar.h>`

Inheritance diagram for wxToolBar:
[legend]

## Detailed Description

A toolbar is a bar of buttons and/or other controls usually placed below the menu bar in a wxFrame.

You may create a toolbar that is managed by a frame calling wxFrame::CreateToolBar(). Under Pocket PC, you should always use this function for creating the toolbar to be managed by the frame, so that wxWidgets can use a combined menubar and toolbar. Where you manage your own toolbars, create wxToolBar as usual.

There are several different types of tools you can add to a toolbar. These types are controlled by the wxItemKind enumeration.

Note that many methods in wxToolBar such as wxToolBar::AddTool return a `wxToolBarToolBase*` object. This should be regarded as an opaque handle representing the newly added toolbar item, providing access to its id and position within the toolbar. Changes to the item's state should be made through calls to wxToolBar methods, for example wxToolBar::EnableTool. Calls to `wxToolBarToolBase` methods (undocumented by purpose) will not change the visible state of the item within the tool bar.

After you have added all the tools you need, you must call Realize() to effectively construct and display the toolbar.

wxMSW note: Note that under wxMSW toolbar paints tools to reflect system-wide colours. If you use more than 16 colours in your tool bitmaps, you may wish to suppress this behaviour, otherwise system colours in your bitmaps will inadvertently be mapped to system colours. To do this, set the msw.remap system option before creating the toolbar:

wxSystemOptions::SetOption("msw.remap", 0);
wxSystemOptions::SetOption
static void SetOption(const wxString &name, const wxString &value)
Sets an option.

If you wish to use 32-bit images (which include an alpha channel for transparency) use:

wxSystemOptions::SetOption("msw.remap", 2);

Then colour remapping is switched off, and a transparent background used. But only use this option under Windows XP with true colour:

if (wxTheApp->GetComCtl32Version() >= 600 && ::wxDisplayDepth() >= 32)
wxDisplayDepth
int wxDisplayDepth()
Returns the depth of the display (a value of 1 denotes a monochrome display).
wxTheApp
wxApp * wxTheApp
The global pointer to the singleton wxApp object.
Definition: app.h:1160

## Styles

This class supports the following styles:

- wxTB_FLAT:
  Gives the toolbar a flat look (Windows and GTK only).
- wxTB_DOCKABLE:
  Makes the toolbar floatable and dockable (GTK only).
- wxTB_HORIZONTAL:
  Specifies horizontal layout (default).
- wxTB_VERTICAL:
  Specifies vertical layout.
- wxTB_TEXT:
  Shows the text in the toolbar buttons; by default only icons are shown.
- wxTB_NOICONS:
  Specifies no icons in the toolbar buttons; by default they are shown.
- wxTB_NODIVIDER:
  Specifies no divider (border) above the toolbar (Windows only)
- wxTB_NOALIGN:
  Specifies no alignment with the parent window (Windows only, not very useful).
- wxTB_HORZ_LAYOUT:
  Shows the text and the icons alongside, not vertically stacked (Windows and GTK 2 only). This style must be used with `wxTB_TEXT`.
- wxTB_HORZ_TEXT:
  Combination of `wxTB_HORZ_LAYOUT` and `wxTB_TEXT`.
- wxTB_NO_TOOLTIPS:
  Don't show the short help tooltips for the tools when the mouse hovers over them.
- wxTB_BOTTOM:
  Align the toolbar at the bottom of parent window.
- wxTB_RIGHT:
  Align the toolbar at the right side of parent window.
- wxTB_DEFAULT_STYLE:
  The `wxTB_HORIZONTAL` style. This style is new since wxWidgets 2.9.5.
  See also Window Styles. Note that the wxMSW native toolbar ignores `wxTB_NOICONS` style. Also, toggling the `wxTB_TEXT` works only if the style was initially on.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxCommandEvent& event)

Event macros for events emitted by this class:

- EVT_TOOL(id, func):
  Process a `wxEVT_TOOL` event (a synonym for `wxEVT_MENU`). Pass the id of the tool.
- EVT_MENU(id, func):
  The same as EVT_TOOL().
- EVT_TOOL_RANGE(id1, id2, func):
  Process a `wxEVT_TOOL` event for a range of identifiers. Pass the ids of the tools.
- EVT_MENU_RANGE(id1, id2, func):
  The same as EVT_TOOL_RANGE().
- EVT_TOOL_RCLICKED(id, func):
  Process a `wxEVT_TOOL_RCLICKED` event. Pass the id of the tool. (Not available on wxOSX.)
- EVT_TOOL_RCLICKED_RANGE(id1, id2, func):
  Process a `wxEVT_TOOL_RCLICKED` event for a range of ids. Pass the ids of the tools. (Not available on wxOSX.)
- EVT_TOOL_ENTER(id, func):
  Process a `wxEVT_TOOL_ENTER` event. Pass the id of the toolbar itself. The value of wxCommandEvent::GetSelection() is the tool id, or -1 if the mouse cursor has moved off a tool. (Not available on wxOSX.)
- EVT_TOOL_DROPDOWN(id, func):
  Process a `wxEVT_TOOL_DROPDOWN` event. If unhandled, displays the default dropdown menu set using wxToolBar::SetDropdownMenu().
  The toolbar class emits menu commands in the same way that a frame menubar does, so you can use one EVT_MENU() macro for both a menu item and a toolbar button. The event handler functions take a wxCommandEvent argument. For most event macros, the identifier of the tool is passed, but for EVT_TOOL_ENTER() the toolbar window identifier is passed and the tool identifier is retrieved from the wxCommandEvent. This is because the identifier may be `wxID_ANY` when the mouse moves off a tool, and `wxID_ANY` is not allowed as an identifier in the event system.

##

Library: wxCore

<>< =''>:</>&;&;< =''>\ </></>

See also
  Toolbar Overview

## Public Member Functions
| wxToolBar ()
| Default constructor. More...
| wxToolBar (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTB_HORIZONTAL, const wxString &name=wxToolBarNameStr)
| Constructs a toolbar. More...
virtual | ~wxToolBar ()
| Toolbar destructor. More...
wxToolBarToolBase * | AddCheckTool (int toolId, const wxString &label, const wxBitmap &bitmap1, const wxBitmap &bmpDisabled=wxNullBitmap, const wxString &shortHelp=wxEmptyString, const wxString &longHelp=wxEmptyString, wxObject *clientData=NULL)
| Adds a new check (or toggle) tool to the toolbar. More...
virtual wxToolBarToolBase * | AddControl (wxControl *control, const wxString &label=wxEmptyString)
| Adds any control to the toolbar, typically e.g. a wxComboBox. More...
wxToolBarToolBase * | AddRadioTool (int toolId, const wxString &label, const wxBitmap &bitmap1, const wxBitmap &bmpDisabled=wxNullBitmap, const wxString &shortHelp=wxEmptyString, const wxString &longHelp=wxEmptyString, wxObject *clientData=NULL)
| Adds a new radio tool to the toolbar. More...
virtual wxToolBarToolBase * | AddSeparator ()
| Adds a separator for spacing groups of tools. More...
wxToolBarToolBase * | AddStretchableSpace ()
| Adds a stretchable space to the toolbar. More...
virtual wxToolBarToolBase * | AddTool (wxToolBarToolBase *tool)
| Adds a tool to the toolbar. More...
wxToolBarToolBase * | AddTool (int toolId, const wxString &label, const wxBitmap &bitmap, const wxString &shortHelp=wxEmptyString, wxItemKind kind=wxITEM_NORMAL)
| Adds a tool to the toolbar. More...
wxToolBarToolBase * | AddTool (int toolId, const wxString &label, const wxBitmap &bitmap, const wxBitmap &bmpDisabled, wxItemKind kind=wxITEM_NORMAL, const wxString &shortHelp=wxEmptyString, const wxString &longHelp=wxEmptyString, wxObject *clientData=NULL)
| Adds a tool to the toolbar. More...
virtual void | ClearTools ()
| Deletes all the tools in the toolbar. More...
virtual bool | DeleteTool (int toolId)
| Removes the specified tool from the toolbar and deletes it. More...
virtual bool | DeleteToolByPos (size_t pos)
| This function behaves like DeleteTool() but it deletes the tool at the specified position and not the one with the given id. More...
virtual void | EnableTool (int toolId, bool enable)
| Enables or disables the tool. More...
wxToolBarToolBase * | FindById (int id) const
| Returns a pointer to the tool identified by id or NULL if no corresponding tool is found. More...
virtual wxControl * | FindControl (int id)
| Returns a pointer to the control identified by id or NULL if no corresponding control is found. More...
virtual wxToolBarToolBase * | FindToolForPosition (wxCoord x, wxCoord y) const
| Finds a tool for the given mouse position. More...
wxSize | GetMargins () const
| Returns the left/right and top/bottom margins, which are also used for inter-toolspacing. More...
virtual wxSize | GetToolBitmapSize () const
| Returns the size of bitmap that the toolbar expects to have. More...
wxToolBarToolBase * | GetToolByPos (int pos)
| Returns a pointer to the tool at ordinal position pos. More...
const wxToolBarToolBase * | GetToolByPos (int pos) const
virtual wxObject * | GetToolClientData (int toolId) const
| Get any client data associated with the tool. More...
virtual bool | GetToolEnabled (int toolId) const
| Called to determine whether a tool is enabled (responds to user input). More...
virtual wxString | GetToolLongHelp (int toolId) const
| Returns the long help for the given tool. More...
virtual int | GetToolPacking () const
| Returns the value used for packing tools. More...
virtual int | GetToolPos (int toolId) const
| Returns the tool position in the toolbar, or `wxNOT_FOUND` if the tool is not found. More...
virtual int | GetToolSeparation () const
| Returns the default separator size. More...
virtual wxString | GetToolShortHelp (int toolId) const
| Returns the short help for the given tool. More...
virtual wxSize | GetToolSize () const
| Returns the size of a whole button, which is usually larger than a tool bitmap because of added 3D effects. More...
virtual bool | GetToolState (int toolId) const
| Gets the on/off state of a toggle tool. More...
size_t | GetToolsCount () const
| Returns the number of tools in the toolbar. More...
virtual wxToolBarToolBase * | InsertControl (size_t pos, wxControl *control, const wxString &label=wxEmptyString)
| Inserts the control into the toolbar at the given position. More...
virtual wxToolBarToolBase * | InsertSeparator (size_t pos)
| Inserts the separator into the toolbar at the given position. More...
wxToolBarToolBase * | InsertStretchableSpace (size_t pos)
| Inserts a stretchable space at the given position. More...
wxToolBarToolBase * | InsertTool (size_t pos, int toolId, const wxString &label, const wxBitmap &bitmap, const wxBitmap &bmpDisabled=wxNullBitmap, wxItemKind kind=wxITEM_NORMAL, const wxString &shortHelp=wxEmptyString, const wxString &longHelp=wxEmptyString, wxObject *clientData=NULL)
| Inserts the tool with the specified attributes into the toolbar at the given position. More...
wxToolBarToolBase * | InsertTool (size_t pos, wxToolBarToolBase *tool)
virtual bool | OnLeftClick (int toolId, bool toggleDown)
| Called when the user clicks on a tool with the left mouse button. More...
virtual void | OnMouseEnter (int toolId)
| This is called when the mouse cursor moves into a tool or out of the toolbar. More...
virtual void | OnRightClick (int toolId, long x, long y)
virtual bool | Realize ()
| This function should be called after you have added tools. More...
virtual wxToolBarToolBase * | RemoveTool (int id)
| Removes the given tool from the toolbar but doesn't delete it. More...
bool | SetDropdownMenu (int id, wxMenu *menu)
| Sets the dropdown menu for the tool given by its id. More...
virtual void | SetMargins (int x, int y)
| Set the values to be used as margins for the toolbar. More...
void | SetMargins (const wxSize &size)
| Set the margins for the toolbar. More...
virtual void | SetToolBitmapSize (const wxSize &size)
| Sets the default size of each tool bitmap. More...
virtual void | SetToolClientData (int id, wxObject *clientData)
| Sets the client data associated with the tool. More...
virtual void | SetToolDisabledBitmap (int id, const wxBitmap &bitmap)
| Sets the bitmap to be used by the tool with the given ID when the tool is in a disabled state. More...
virtual void | SetToolLongHelp (int toolId, const wxString &helpString)
| Sets the long help for the given tool. More...
virtual void | SetToolNormalBitmap (int id, const wxBitmap &bitmap)
| Sets the bitmap to be used by the tool with the given ID. More...
virtual void | SetToolPacking (int packing)
| Sets the value used for spacing tools. More...
virtual void | SetToolSeparation (int separation)
| Sets the default separator size. More...
virtual void | SetToolShortHelp (int toolId, const wxString &helpString)
| Sets the short help for the given tool. More...
virtual void | ToggleTool (int toolId, bool toggle)
| Toggles a tool on or off. More...
virtual wxToolBarToolBase * | CreateTool (int toolId, const wxString &label, const wxBitmap &bmpNormal, const wxBitmap &bmpDisabled=wxNullBitmap, wxItemKind kind=wxITEM_NORMAL, wxObject *clientData=NULL, const wxString &shortHelp=wxEmptyString, const wxString &longHelp=wxEmptyString)
| Factory function to create a new toolbar tool. More...
virtual wxToolBarToolBase * | CreateTool (wxControl *control, const wxString &label)
| Factory function to create a new control toolbar tool. More...
wxToolBarToolBase * | CreateSeparator ()
| Factory function to create a new separator toolbar tool. More...
Public Member Functions inherited from wxControl
| wxControl (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
| Constructs a control. More...
| wxControl ()
| Default constructor to allow 2-phase creation. More...
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxValidator &validator=wxDefaultValidator, const wxString &name=wxControlNameStr)
virtual void | Command (wxCommandEvent &event)
| Simulates the effect of the user issuing a command to the item. More...
wxString | GetLabel () const
| Returns the control's label, as it was passed to SetLabel(). More...
wxString | GetLabelText () const
| Returns the control's label without mnemonics. More...
wxSize | GetSizeFromTextSize (int xlen, int ylen=-1) const
| Determine the size needed by the control to leave the given area for its text. More...
wxSize | GetSizeFromTextSize (const wxSize &tsize) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxSize | GetSizeFromText (const wxString &text) const
| Determine the minimum size needed by the control to display the given text. More...
void | SetLabel (const wxString &label)
| Sets the control's label. More...
void | SetLabelText (const wxString &text)
| Sets the control's label to exactly the given string. More...
bool | SetLabelMarkup (const wxString &markup)
| Sets the controls label to a string using markup. More...
Public Member Functions inherited from wxWindow
| wxWindow ()
| Default constructor. More...
| wxWindow (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Constructs a window, which can be a child of a frame, dialog or any other non-control window. More...
virtual | ~wxWindow ()
| Destructor. More...
bool | Create (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=0, const wxString &name=wxPanelNameStr)
| Construct the actual window object after creating the C++ object. More...
virtual bool | AcceptsFocus () const
| This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus. More...
virtual bool | AcceptsFocusFromKeyboard () const
| This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard. More...
virtual bool | AcceptsFocusRecursively () const
| Overridden to indicate whether this window or one of its children accepts focus. More...
void | DisableFocusFromKeyboard ()
| Disable giving focus to this window using the keyboard navigation keys. More...
bool | IsFocusable () const
| Can this window itself have focus? More...
bool | CanAcceptFocus () const
| Can this window have focus right now? More...
bool | CanAcceptFocusFromKeyboard () const
| Can this window be assigned focus from keyboard right now? More...
virtual bool | HasFocus () const
| Returns true if the window (or in case of composite controls, its main child window) has focus. More...
virtual void | SetCanFocus (bool canFocus)
| This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0). More...
virtual void | EnableVisibleFocus (bool enable)
| Enables or disables visible indication of keyboard focus. More...
virtual void | SetFocus ()
| This sets the window to receive keyboard input. More...
virtual void | SetFocusFromKbd ()
| This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g. using `TAB` key). More...
virtual void | AddChild (wxWindow *child)
| Adds a child window. More...
bool | DestroyChildren ()
| Destroys all children of a window. More...
wxWindow * | FindWindow (long id) const
| Find a child of this window, by id. More...
wxWindow * | FindWindow (const wxString &name) const
| Find a child of this window, by name. More...
wxWindowList & | GetChildren ()
| Returns a reference to the list of the window's children. More...
const wxWindowList & | GetChildren () const
| Returns a const reference to the list of the window's children. More...
virtual void | RemoveChild (wxWindow *child)
| Removes a child window. More...
wxWindow * | GetGrandParent () const
| Returns the grandparent of a window, or NULL if there isn't one. More...
wxWindow * | GetNextSibling () const
| Returns the next window after this one among the parent's children or NULL if this window is the last child. More...
wxWindow * | GetParent () const
| Returns the parent of the window, or NULL if there is no parent. More...
wxWindow * | GetPrevSibling () const
| Returns the previous window before this one among the parent's children or `` NULL if this window is the first child. More...
bool | IsDescendant (wxWindow *win) const
| Check if the specified window is a descendant of this one. More...
virtual bool | Reparent (wxWindow *newParent)
| Reparents the window, i.e. the window will be removed from its current parent window (e.g. More...
virtual void | AlwaysShowScrollbars (bool hflag=true, bool vflag=true)
| Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling. More...
virtual int | GetScrollPos (int orientation) const
| Returns the built-in scrollbar position. More...
virtual int | GetScrollRange (int orientation) const
| Returns the built-in scrollbar range. More...
virtual int | GetScrollThumb (int orientation) const
| Returns the built-in scrollbar thumb size. More...
bool | CanScroll (int orient) const
| Returns true if this window can have a scroll bar in this orientation. More...
bool | HasScrollbar (int orient) const
| Returns true if this window currently has a scroll bar for this orientation. More...
virtual bool | IsScrollbarAlwaysShown (int orient) const
| Return whether a scrollbar is always shown. More...
virtual bool | ScrollLines (int lines)
| Scrolls the window by the given number of lines down (if lines is positive) or up. More...
virtual bool | ScrollPages (int pages)
| Scrolls the window by the given number of pages down (if pages is positive) or up. More...
virtual void | ScrollWindow (int dx, int dy, const wxRect *rect=NULL)
| Physically scrolls the pixels in the window and move child windows accordingly. More...
bool | LineUp ()
| Same as ScrollLines (-1). More...
bool | LineDown ()
| Same as ScrollLines (1). More...
bool | PageUp ()
| Same as ScrollPages (-1). More...
bool | PageDown ()
| Same as ScrollPages (1). More...
virtual void | SetScrollPos (int orientation, int pos, bool refresh=true)
| Sets the position of one of the built-in scrollbars. More...
virtual void | SetScrollbar (int orientation, int position, int thumbSize, int range, bool refresh=true)
| Sets the scrollbar properties of a built-in scrollbar. More...
void | Center (int dir=wxBOTH)
| A synonym for Centre(). More...
void | CenterOnParent (int dir=wxBOTH)
| A synonym for CentreOnParent(). More...
void | Centre (int direction=wxBOTH)
| Centres the window. More...
void | CentreOnParent (int direction=wxBOTH)
| Centres the window on its parent. More...
void | GetPosition (int *x, int *y) const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows. More...
wxPoint | GetPosition () const
| This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows. More...
wxRect | GetRect () const
| Returns the position and size of the window as a wxRect object. More...
void | GetScreenPosition (int *x, int *y) const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one. More...
wxPoint | GetScreenPosition () const
| Returns the window position in screen coordinates, whether the window is a child window or a top level one. More...
wxRect | GetScreenRect () const
| Returns the position and size of the window on the screen as a wxRect object. More...
virtual wxPoint | GetClientAreaOrigin () const
| Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...) More...
wxRect | GetClientRect () const
| Get the client rectangle in window (i.e. client) coordinates. More...
void | Move (int x, int y, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position. More...
void | Move (const wxPoint &pt, int flags=wxSIZE_USE_EXISTING)
| Moves the window to the given position. More...
void | SetPosition (const wxPoint &pt)
| Moves the window to the specified position. More...
void | ClientToScreen (int *x, int *y) const
| Converts to screen coordinates from coordinates relative to this window. More...
wxPoint | ClientToScreen (const wxPoint &pt) const
| Converts to screen coordinates from coordinates relative to this window. More...
wxPoint | ConvertDialogToPixels (const wxPoint &pt) const
| Converts a point or size from dialog units to pixels. More...
wxSize | ConvertDialogToPixels (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxPoint | ConvertPixelsToDialog (const wxPoint &pt) const
| Converts a point or size from pixels to dialog units. More...
wxSize | ConvertPixelsToDialog (const wxSize &sz) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | ScreenToClient (int *x, int *y) const
| Converts from screen to client window coordinates. More...
wxPoint | ScreenToClient (const wxPoint &pt) const
| Converts from screen to client window coordinates. More...
virtual void | ClearBackground ()
| Clears the window by filling it with the current background colour. More...
void | Freeze ()
| Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all. More...
void | Thaw ()
| Re-enables window updating after a previous call to Freeze(). More...
bool | IsFrozen () const
| Returns true if the window is currently frozen by a call to Freeze(). More...
wxColour | GetBackgroundColour () const
| Returns the background colour of the window. More...
virtual wxBackgroundStyle | GetBackgroundStyle () const
| Returns the background style of the window. More...
virtual int | GetCharHeight () const
| Returns the character height for this window. More...
virtual int | GetCharWidth () const
| Returns the average character width for this window. More...
virtual wxVisualAttributes | GetDefaultAttributes () const
| Currently this is the same as calling wxWindow::GetClassDefaultAttributes(wxWindow::GetWindowVariant()). More...
virtual wxSize | GetDPI () const
| Return the DPI of the display used by this window. More...
wxFont | GetFont () const
| Returns the font for this window. More...
wxColour | GetForegroundColour () const
| Returns the foreground colour of the window. More...
void | GetTextExtent (const wxString &string, int *w, int *h, int *descent=NULL, int *externalLeading=NULL, const wxFont *font=NULL) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font. More...
wxSize | GetTextExtent (const wxString &string) const
| Gets the dimensions of the string as it would be drawn on the window with the currently selected font. More...
const wxRegion & | GetUpdateRegion () const
| Returns the region specifying which parts of the window have been damaged. More...
wxRect | GetUpdateClientRect () const
| Get the update rectangle bounding box in client coords. More...
virtual bool | HasTransparentBackground ()
| Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background. More...
virtual void | Refresh (bool eraseBackground=true, const wxRect *rect=NULL)
| Causes this window, and all of its children recursively (except under wxGTK1 where this is not implemented), to be repainted. More...
void | RefreshRect (const wxRect &rect, bool eraseBackground=true)
| Redraws the contents of the given rectangle: only the area inside it will be repainted. More...
virtual void | Update ()
| Calling this method immediately repaints the invalidated area of the window and all of its children recursively (this normally only happens when the flow of control returns to the event loop). More...
virtual bool | SetBackgroundColour (const wxColour &colour)
| Sets the background colour of the window. More...
virtual bool | SetBackgroundStyle (wxBackgroundStyle style)
| Sets the background style of the window. More...
virtual bool | IsTransparentBackgroundSupported (wxString *reason=NULL) const
| Checks whether using transparent background might work. More...
virtual bool | SetFont (const wxFont &font)
| Sets the font for this window. More...
virtual bool | SetForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window. More...
void | SetOwnBackgroundColour (const wxColour &colour)
| Sets the background colour of the window but prevents it from being inherited by the children of this window. More...
bool | InheritsBackgroundColour () const
| Return true if this window inherits the background colour from its parent. More...
bool | UseBgCol () const
| Return true if a background colour has been set for this window. More...
bool | UseBackgroundColour () const
| Return true if a background colour has been set for this window. More...
void | SetOwnFont (const wxFont &font)
| Sets the font of the window but prevents it from being inherited by the children of this window. More...
void | SetOwnForegroundColour (const wxColour &colour)
| Sets the foreground colour of the window but prevents it from being inherited by the children of this window. More...
bool | UseForegroundColour () const
| Return true if a foreground colour has been set for this window. More...
bool | InheritsForegroundColour () const
| Return true if this window inherits the foreground colour from its parent. More...
void | SetPalette (const wxPalette &pal)
virtual bool | ShouldInheritColours () const
| Return true from here to allow the colours of this window to be changed by InheritAttributes(). More...
virtual void | SetThemeEnabled (bool enable)
| This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code. More...
virtual bool | GetThemeEnabled () const
| Returns true if the window uses the system theme for drawing its background. More...
virtual bool | CanSetTransparent ()
| Returns true if the system supports transparent windows and calling SetTransparent() may succeed. More...
virtual bool | SetTransparent (wxByte alpha)
| Set the transparency of the window. More...
wxEvtHandler * | GetEventHandler () const
| Returns the event handler for this window. More...
bool | HandleAsNavigationKey (const wxKeyEvent &event)
| This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case. More...
bool | HandleWindowEvent (wxEvent &event) const
| Shorthand for: More...
bool | ProcessWindowEvent (wxEvent &event)
| Convenient wrapper for ProcessEvent(). More...
bool | ProcessWindowEventLocally (wxEvent &event)
| Wrapper for wxEvtHandler::ProcessEventLocally(). More...
wxEvtHandler * | PopEventHandler (bool deleteHandler=false)
| Removes and returns the top-most event handler on the event handler stack. More...
void | PushEventHandler (wxEvtHandler *handler)
| Pushes this event handler onto the event stack for the window. More...
bool | RemoveEventHandler (wxEvtHandler *handler)
| Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack. More...
void | SetEventHandler (wxEvtHandler *handler)
| Sets the event handler for this window. More...
virtual void | SetNextHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called. More...
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| wxWindows cannot be used to form event handler chains; this function thus will assert when called. More...
long | GetExtraStyle () const
| Returns the extra style bits for the window. More...
virtual long | GetWindowStyleFlag () const
| Gets the window style that was passed to the constructor or Create() method. More...
long | GetWindowStyle () const
| See GetWindowStyleFlag() for more info. More...
bool | HasExtraStyle (int exFlag) const
| Returns true if the window has the given exFlag bit set in its extra styles. More...
bool | HasFlag (int flag) const
| Returns true if the window has the given flag bit set. More...
virtual void | SetExtraStyle (long exStyle)
| Sets the extra style bits for the window. More...
virtual void | SetWindowStyleFlag (long style)
| Sets the style of the window. More...
void | SetWindowStyle (long style)
| See SetWindowStyleFlag() for more info. More...
bool | ToggleWindowStyle (int flag)
| Turns the given flag on if it's currently turned off and vice versa. More...
void | MoveAfterInTabOrder (wxWindow *win)
| Moves this window in the tab navigation order after the specified win. More...
void | MoveBeforeInTabOrder (wxWindow *win)
| Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it. More...
bool | Navigate (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action starting from this window. More...
bool | NavigateIn (int flags=wxNavigationKeyEvent::IsForward)
| Performs a keyboard navigation action inside this window. More...
virtual void | Lower ()
| Lowers the window to the bottom of the window hierarchy (Z-order). More...
virtual void | Raise ()
| Raises the window to the top of the window hierarchy (Z-order). More...
bool | Hide ()
| Equivalent to calling wxWindow::Show(false). More...
virtual bool | HideWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function hides a window, like Hide(), but using a special visual effect if possible. More...
bool | IsEnabled () const
| Returns true if the window is enabled, i.e. if it accepts user input, false otherwise. More...
bool | IsExposed (int x, int y) const
| Returns true if the given point or rectangle area has been exposed since the last repaint. More...
bool | IsExposed (wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | IsExposed (int x, int y, int w, int h) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | IsExposed (wxRect &rect) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual bool | IsShown () const
| Returns true if the window is shown, false if it has been hidden. More...
virtual bool | IsShownOnScreen () const
| Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well. More...
bool | Disable ()
| Disables the window. More...
virtual bool | Enable (bool enable=true)
| Enable or disable the window for user input. More...
virtual bool | Show (bool show=true)
| Shows or hides the window. More...
virtual bool | ShowWithEffect (wxShowEffect effect, unsigned int timeout=0)
| This function shows a window, like Show(), but using a special visual effect if possible. More...
wxString | GetHelpText () const
| Gets the help text to be used as context-sensitive help for this window. More...
void | SetHelpText (const wxString &helpText)
| Sets the help text to be used as context-sensitive help for this window. More...
virtual wxString | GetHelpTextAtPoint (const wxPoint &point, wxHelpEvent::Origin origin) const
| Gets the help text to be used as context-sensitive help for this window. More...
wxToolTip * | GetToolTip () const
| Get the associated tooltip or NULL if none. More...
wxString | GetToolTipText () const
| Get the text of the associated tooltip or empty string if none. More...
void | SetToolTip (const wxString &tipString)
| Attach a tooltip to the window. More...
void | SetToolTip (wxToolTip *tip)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | UnsetToolTip ()
| Unset any existing tooltip. More...
int | GetPopupMenuSelectionFromUser (wxMenu &menu, const wxPoint &pos=wxDefaultPosition)
| This function shows a popup menu at the given position in this window and returns the selected id. More...
int | GetPopupMenuSelectionFromUser (wxMenu &menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
bool | PopupMenu (wxMenu *menu, const wxPoint &pos=wxDefaultPosition)
| Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu. More...
bool | PopupMenu (wxMenu *menu, int x, int y)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual wxValidator * | GetValidator ()
| Validator functions. More...
virtual void | SetValidator (const wxValidator &validator)
| Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type. More...
virtual bool | TransferDataFromWindow ()
| Transfers values from child controls to data areas specified by their validators. More...
virtual bool | TransferDataToWindow ()
| Transfers values to child controls from data areas specified by their validators. More...
virtual bool | Validate ()
| Validates the current values of the child controls using their validators. More...
wxWindowID | GetId () const
| Returns the identifier of the window. More...
virtual wxLayoutDirection | GetLayoutDirection () const
| Returns the layout direction for this window, Note that `wxLayout_Default` is returned if layout direction is not supported. More...
virtual wxCoord | AdjustForLayoutDirection (wxCoord x, wxCoord width, wxCoord widthTotal) const
| Mirror coordinates for RTL layout if this window uses it and if the mirroring is not done automatically like Win32. More...
virtual wxString | GetName () const
| Returns the window's name. More...
wxWindowVariant | GetWindowVariant () const
| Returns the value previously passed to SetWindowVariant(). More...
void | SetId (wxWindowID winid)
| Sets the identifier of the window. More...
virtual void | SetLayoutDirection (wxLayoutDirection dir)
| Sets the layout direction for this window. More...
virtual void | SetName (const wxString &name)
| Sets the window's name. More...
void | SetWindowVariant (wxWindowVariant variant)
| Chooses a different variant of the window display to use. More...
wxAcceleratorTable * | GetAcceleratorTable ()
| Gets the accelerator table for this window. More...
wxAccessible * | GetAccessible ()
| Returns the accessible object for this window, if any. More...
virtual void | SetAcceleratorTable (const wxAcceleratorTable &accel)
| Sets the accelerator table for this window. More...
void | SetAccessible (wxAccessible *accessible)
| Sets the accessible for this window. More...
bool | Close (bool force=false)
| This function simply generates a wxCloseEvent whose handler usually tries to close the window. More...
virtual bool | Destroy ()
| Destroys the window safely. More...
bool | IsBeingDeleted () const
| Returns true if this window is in process of being destroyed. More...
virtual wxDropTarget * | GetDropTarget () const
| Returns the associated drop target, which may be NULL. More...
virtual void | SetDropTarget (wxDropTarget *target)
| Associates a drop target with this window. More...
virtual void | DragAcceptFiles (bool accept)
| Enables or disables eligibility for drop file events (OnDropFiles). More...
wxSizer * | GetContainingSizer () const
| Returns the sizer of which this window is a member, if any, otherwise NULL. More...
wxSizer * | GetSizer () const
| Returns the sizer associated with the window by a previous call to SetSizer(), or NULL. More...
void | SetSizer (wxSizer *sizer, bool deleteOld=true)
| Sets the window to have the given layout sizer. More...
void | SetSizerAndFit (wxSizer *sizer, bool deleteOld=true)
| Associate the sizer with the window and set the window size and minimal size accordingly. More...
wxLayoutConstraints * | GetConstraints () const
| Returns a pointer to the window's layout constraints, or NULL if there are none. More...
void | SetConstraints (wxLayoutConstraints *constraints)
| Sets the window to have the given layout constraints. More...
virtual bool | Layout ()
| Lays out the children of this window using the associated sizer. More...
void | SetAutoLayout (bool autoLayout)
| Determines whether the Layout() function will be called automatically when the window is resized. More...
bool | GetAutoLayout () const
| Returns true if Layout() is called automatically when the window is resized. More...
void | CaptureMouse ()
| Directs all mouse input to this window. More...
wxCaret * | GetCaret () const
| Returns the caret() associated with the window. More...
const wxCursor & | GetCursor () const
| Return the cursor associated with this window. More...
virtual bool | HasCapture () const
| Returns true if this window has the current mouse capture. More...
void | ReleaseMouse ()
| Releases mouse input captured with CaptureMouse(). More...
void | SetCaret (wxCaret *caret)
| Sets the caret() associated with the window. More...
virtual bool | SetCursor (const wxCursor &cursor)
| Sets the window's cursor. More...
virtual void | WarpPointer (int x, int y)
| Moves the pointer to the given position on the window. More...
virtual bool | EnableTouchEvents (int eventsMask)
| Request generation of touch events for this window. More...
wxHitTest | HitTest (wxCoord x, wxCoord y) const
| Return where the given point lies, exactly. More...
wxHitTest | HitTest (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
wxBorder | GetBorder (long flags) const
| Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable. More...
wxBorder | GetBorder () const
| Get border for the flags of this window. More...
virtual void | DoUpdateWindowUI (wxUpdateUIEvent &event)
| Does the window-specific updating after processing the update event. More...
virtual WXWidget | GetHandle () const
| Returns the platform-specific handle of the physical window. More...
virtual bool | HasMultiplePages () const
| This method should be overridden to return true if this window has multiple pages. More...
virtual void | InheritAttributes ()
| This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours. More...
virtual void | InitDialog ()
| Sends an `wxEVT_INIT_DIALOG` event, whose handler usually transfers data to the dialog via validators. More...
virtual bool | IsDoubleBuffered () const
| Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later. More...
void | SetDoubleBuffered (bool on)
| Turn on or off double buffering of the window if the system supports it. More...
virtual bool | IsRetained () const
| Returns true if the window is retained, false otherwise. More...
bool | IsThisEnabled () const
| Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called. More...
virtual bool | IsTopLevel () const
| Returns true if the given window is a top-level one. More...
virtual void | OnInternalIdle ()
| This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class. More...
virtual bool | SendIdleEvents (wxIdleEvent &event)
| Send idle event to window and all subwindows. More...
virtual bool | RegisterHotKey (int hotkeyId, int modifiers, int virtualKeyCode)
| Registers a system wide hotkey. More...
virtual bool | UnregisterHotKey (int hotkeyId)
| Unregisters a system wide hotkey. More...
virtual void | UpdateWindowUI (long flags=wxUPDATE_UI_NONE)
| This function sends one or more wxUpdateUIEvent to the window. More...
bool | BeginRepositioningChildren ()
| Prepare for changing positions of multiple child windows. More...
void | EndRepositioningChildren ()
| Fix child window positions after setting all of them at once. More...
void | CacheBestSize (const wxSize &size) const
| Sets the cached best size value. More...
virtual wxSize | ClientToWindowSize (const wxSize &size) const
| Converts client area size size to corresponding window size. More...
virtual wxSize | WindowToClientSize (const wxSize &size) const
| Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size. More...
virtual void | Fit ()
| Sizes the window to fit its best size. More...
virtual void | FitInside ()
| Similar to Fit(), but sizes the interior (virtual) size of a window. More...
wxSize | FromDIP (const wxSize &sz) const
| Convert DPI-independent pixel values to the value in pixels appropriate for the current toolkit. More...
wxPoint | FromDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
int | FromDIP (int d) const
| Convert DPI-independent distance in pixels to the value in pixels appropriate for the current toolkit. More...
wxSize | ToDIP (const wxSize &sz) const
| Convert pixel values of the current toolkit to DPI-independent pixel values. More...
wxPoint | ToDIP (const wxPoint &pt) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
int | ToDIP (int d) const
| Convert pixel values of the current toolkit to DPI-independent pixel values. More...
wxSize | GetBestSize () const
| This functions returns the best acceptable minimal size for the window. More...
int | GetBestHeight (int width) const
| Returns the best height needed by this window if it had the given width. More...
int | GetBestWidth (int height) const
| Returns the best width needed by this window if it had the given height. More...
void | GetClientSize (int *width, int *height) const
| Returns the size of the window 'client area' in pixels. More...
wxSize | GetClientSize () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual wxSize | GetEffectiveMinSize () const
| Merges the window's best size into the min size and returns the result. More...
virtual wxSize | GetMaxClientSize () const
| Returns the maximum size of window's client area. More...
virtual wxSize | GetMaxSize () const
| Returns the maximum size of the window. More...
virtual wxSize | GetMinClientSize () const
| Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area. More...
virtual wxSize | GetMinSize () const
| Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size. More...
int | GetMinWidth () const
| Returns the horizontal component of window minimal size. More...
int | GetMinHeight () const
| Returns the vertical component of window minimal size. More...
int | GetMaxWidth () const
| Returns the horizontal component of window maximal size. More...
int | GetMaxHeight () const
| Returns the vertical component of window maximal size. More...
void | GetSize (int *width, int *height) const
| Returns the size of the entire window in pixels, including title bar, border, scrollbars, etc. More...
wxSize | GetSize () const
| See the GetSize(int*,int*) overload for more info. More...
wxSize | GetVirtualSize () const
| This gets the virtual size of the window in pixels. More...
void | GetVirtualSize (int *width, int *height) const
| Like the other GetVirtualSize() overload but uses pointers instead. More...
virtual wxSize | GetBestVirtualSize () const
| Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means) More...
double | GetContentScaleFactor () const
| Returns the factor mapping logical pixels of this window to physical pixels. More...
double | GetDPIScaleFactor () const
| Returns the ratio of the DPI used by this window to the standard DPI. More...
virtual wxSize | GetWindowBorderSize () const
| Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively. More...
virtual bool | InformFirstDirection (int direction, int size, int availableOtherDir)
| wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known. More...
void | InvalidateBestSize ()
| Resets the cached best size value so it will be recalculated the next time it is needed. More...
void | PostSizeEvent ()
| Posts a size event to the window. More...
void | PostSizeEventToParent ()
| Posts a size event to the parent of this window. More...
virtual void | SendSizeEvent (int flags=0)
| This function sends a dummy size event to the window allowing it to re-layout its children positions. More...
void | SendSizeEventToParent (int flags=0)
| Safe wrapper for GetParent()->SendSizeEvent(). More...
void | SetClientSize (int width, int height)
| This sets the size of the window client area in pixels. More...
void | SetClientSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetClientSize (const wxRect &rect)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetContainingSizer (wxSizer *sizer)
| Used by wxSizer internally to notify the window about being managed by the given sizer. More...
void | SetInitialSize (const wxSize &size=wxDefaultSize)
| A smart SetSize that will fill in default size components with the window's best size values. More...
virtual void | SetMaxClientSize (const wxSize &size)
| Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area. More...
virtual void | SetMaxSize (const wxSize &size)
| Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size. More...
virtual void | SetMinClientSize (const wxSize &size)
| Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area. More...
virtual void | SetMinSize (const wxSize &size)
| Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size. More...
void | SetSize (int x, int y, int width, int height, int sizeFlags=wxSIZE_AUTO)
| Sets the size of the window in pixels. More...
void | SetSize (const wxRect &rect)
| Sets the size of the window in pixels. More...
void | SetSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetSize (int width, int height)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
virtual void | SetSizeHints (const wxSize &minSize, const wxSize &maxSize=wxDefaultSize, const wxSize &incSize=wxDefaultSize)
| Use of this function for windows which are not toplevel windows (such as wxDialog or wxFrame) is discouraged. More...
virtual void | SetSizeHints (int minW, int minH, int maxW=-1, int maxH=-1, int incW=-1, int incH=-1)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
void | SetVirtualSize (int width, int height)
| Sets the virtual size of the window in pixels. More...
void | SetVirtualSize (const wxSize &size)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor. More...
virtual | ~wxEvtHandler ()
| Destructor. More...
template<typename T , typename T1 , ... >
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method. More...
template<typename T >
void | CallAfter (const T &functor)
| Asynchronously call the given functor. More...
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it. More...
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process. More...
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail. More...
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent(). More...
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type. More...
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info. More...
template<typename EventTag , typename Functor >
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
template<typename EventTag , typename Functor >
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed. More...
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info. More...
void * | GetClientData () const
| Returns user-supplied client data. More...
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object. More...
void | SetClientData (void *data)
| Sets user-supplied client data. More...
void | SetClientObject (wxClientData *data)
| Set the client data object. More...
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise. More...
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain. More...
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain. More...
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler. More...
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted). More...
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL. More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined. More...

## Additional Inherited Members
Static Public Member Functions inherited from wxControl
static wxString | GetLabelText (const wxString &label)
| Returns the given label string without mnemonics ("&" characters). More...
static wxString | RemoveMnemonics (const wxString &str)
| Returns the given str string without mnemonics ("&" characters). More...
static wxString | EscapeMnemonics (const wxString &text)
| Escapes the special mnemonics characters ("&") in the given string. More...
static wxString | Ellipsize (const wxString &label, const wxDC &dc, wxEllipsizeMode mode, int maxWidth, int flags=wxELLIPSIZE_FLAGS_DEFAULT)
| Replaces parts of the label string with ellipsis, if needed, so that it fits into maxWidth pixels if possible. More...
Static Public Member Functions inherited from wxWindow
static wxSize | FromDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific DPI-independent pixels conversion functions. More...
static wxPoint | FromDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static int | FromDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static wxSize | ToDIP (const wxSize &sz, const wxWindow *w)
| Non window-specific pixel to DPI-independent pixels conversion functions. More...
static wxPoint | ToDIP (const wxPoint &pt, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static int | ToDIP (int d, const wxWindow *w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. More...
static wxVisualAttributes | GetClassDefaultAttributes (wxWindowVariant variant=wxWINDOW_VARIANT_NORMAL)
| Returns the default font and colours which are used by the control. More...
static wxWindow * | FindFocus ()
| Finds the window or control which currently has the keyboard focus. More...
static wxWindow * | FindWindowById (long id, const wxWindow *parent=0)
| Find the first window with the given id. More...
static wxWindow * | FindWindowByLabel (const wxString &label, const wxWindow *parent=0)
| Find a window by its label. More...
static wxWindow * | FindWindowByName (const wxString &name, const wxWindow *parent=0)
| Find a window by its name (as given in a window constructor or Create() function call). More...
static wxWindow * | GetCapture ()
| Returns the currently captured window. More...
static wxWindowID | NewControlId (int count=1)
| Create a new ID or range of IDs that are not currently in use. More...
static void | UnreserveControlId (wxWindowID id, int count=1)
| Unreserve an ID or range of IDs that was reserved by NewControlId(). More...
Static Public Member Functions inherited from wxEvtHandler
static void | AddFilter (wxEventFilter *filter)
| Add an event filter whose FilterEvent() method will be called for each and every event processed by wxWidgets. More...
static void | RemoveFilter (wxEventFilter *filter)
| Remove a filter previously installed with AddFilter(). More...
Protected Member Functions inherited from wxWindow
virtual void | DoCentre (int direction)
| Centres the window. More...
virtual wxSize | DoGetBestSize () const
| Implementation of GetBestSize() that can be overridden. More...
virtual wxSize | DoGetBestClientSize () const
| Override this method to return the best size for a custom control. More...
virtual int | DoGetBestClientHeight (int width) const
| Override this method to implement height-for-width best size calculation. More...
virtual int | DoGetBestClientWidth (int height) const
| Override this method to implement width-for-height best size calculation. More...
virtual void | SetInitialBestSize (const wxSize &size)
| Sets the initial window size if none is given (i.e. at least one of the components of the size passed to ctor/Create() is wxDefaultCoord). More...
void | SendDestroyEvent ()
| Generate wxWindowDestroyEvent for this window. More...
virtual bool | ProcessEvent (wxEvent &event)
| This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself. More...
bool | SafelyProcessEvent (wxEvent &event)
| See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. More...
virtual void | QueueEvent (wxEvent *event)
| Returns the default font and colours which are used by the control. More...
virtual void | AddPendingEvent (const wxEvent &event)
| Returns the default font and colours which are used by the control. More...
void | ProcessPendingEvents ()
| Returns the default font and colours which are used by the control. More...
bool | ProcessThreadEvent (const wxEvent &event)
| Returns the default font and colours which are used by the control. More...
Protected Member Functions inherited from wxEvtHandler
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables. More...
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort. More...
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ wxToolBar() [1/2]

wxToolBar::wxToolBar | ( |  | ) |

Default constructor.

## ◆ wxToolBar() [2/2]

wxToolBar::wxToolBar | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxTB_HORIZONTAL`,
|  | const wxString & | name = `wxToolBarNameStr`
| ) |  |

Constructs a toolbar.

Parameters

  parent | Pointer to a parent window.
  id | Window identifier. If -1, will automatically create an identifier.
  pos | Window position. wxDefaultPosition indicates that wxWidgets should generate a default position for the window. If using the wxWindow class directly, supply an actual position.
  size | Window size. wxDefaultSize indicates that wxWidgets should generate a default size for the window.
  style | Window style. See wxToolBar initial description for details.
  name | Window name.

Remarks
  After a toolbar is created, you use AddTool() and perhaps AddSeparator(), and then you must call Realize() to construct and display the toolbar tools.

## ◆ ~wxToolBar()

virtual wxToolBar::~wxToolBar | ( |  | ) |
| virtual

Toolbar destructor.

## Member Function Documentation

## ◆ AddCheckTool()

wxToolBarToolBase * wxToolBar::AddCheckTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap1,
|  | const wxBitmap & | bmpDisabled = `wxNullBitmap`,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | const wxString & | longHelp = `wxEmptyString`,
|  | wxObject * | clientData = `NULL`
| ) |  |

Adds a new check (or toggle) tool to the toolbar.

The parameters are the same as in AddTool().

See also
  AddTool()

## ◆ AddControl()

virtual wxToolBarToolBase * wxToolBar::AddControl | ( | wxControl * | control,
|  | const wxString & | label = `wxEmptyString`
| ) |  |
| virtual

Adds any control to the toolbar, typically e.g. a wxComboBox.

Parameters

  control | The control to be added.
  label | Text to be displayed near the control.

Remarks
  wxMac: labels are only displayed if wxWidgets is built with `wxMAC_USE_NATIVE_TOOLBAR` set to 1

## ◆ AddRadioTool()

wxToolBarToolBase * wxToolBar::AddRadioTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap1,
|  | const wxBitmap & | bmpDisabled = `wxNullBitmap`,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | const wxString & | longHelp = `wxEmptyString`,
|  | wxObject * | clientData = `NULL`
| ) |  |

Adds a new radio tool to the toolbar.

Consecutive radio tools form a radio group such that exactly one button in the group is pressed at any moment, in other words whenever a button in the group is pressed the previously pressed button is automatically released. You should avoid having the radio groups of only one element as it would be impossible for the user to use such button.

By default, the first button in the radio group is initially pressed, the others are not.

See also
  AddTool()

## ◆ AddSeparator()

virtual wxToolBarToolBase * wxToolBar::AddSeparator | ( |  | ) |
| virtual

Adds a separator for spacing groups of tools.

Notice that the separator uses the look appropriate for the current platform so it can be a vertical line (MSW, some versions of GTK) or just an empty space or something else.

See also
  AddTool(), SetToolSeparation(), AddStretchableSpace()

## ◆ AddStretchableSpace()

wxToolBarToolBase * wxToolBar::AddStretchableSpace | ( |  | ) |

Adds a stretchable space to the toolbar.

Any space not taken up by the fixed items (all items except for stretchable spaces) is distributed in equal measure between the stretchable spaces in the toolbar. The most common use for this method is to add a single stretchable space before the items which should be right-aligned in the toolbar, but more exotic possibilities are possible, e.g. a stretchable space may be added in the beginning and the end of the toolbar to centre all toolbar items.

See also
  AddTool(), AddSeparator(), InsertStretchableSpace()

Since
  2.9.1

## ◆ AddTool() [1/3]

wxToolBarToolBase * wxToolBar::AddTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap,
|  | const wxBitmap & | bmpDisabled,
|  | wxItemKind | kind = `wxITEM_NORMAL`,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | const wxString & | longHelp = `wxEmptyString`,
|  | wxObject * | clientData = `NULL`
| ) |  |

Adds a tool to the toolbar.

Parameters

  toolId | An integer by which the tool may be identified in subsequent operations.
  label | The string to be displayed with the tool.
  bitmap | The primary tool bitmap.
  bmpDisabled | The bitmap used when the tool is disabled. If it is equal to wxNullBitmap (default), the disabled bitmap is automatically generated by greying the normal one.
  kind | May be wxITEM_NORMAL for a normal button (default), wxITEM_CHECK for a checkable tool (such tool stays pressed after it had been toggled) or wxITEM_RADIO for a checkable tool which makes part of a radio group of tools each of which is automatically unchecked whenever another button in the group is checked. wxITEM_DROPDOWN specifies that a drop-down menu button will appear next to the tool button (only GTK+ and MSW). Call SetDropdownMenu() afterwards.
  shortHelp | This string is used for the tools tooltip.
  longHelp | This string is shown in the statusbar (if any) of the parent frame when the mouse pointer is inside the tool.
  clientData | An optional pointer to client data which can be retrieved later using GetToolClientData().

Remarks
  After you have added tools to a toolbar, you must call Realize() in order to have the tools appear.

See also
  AddSeparator(), AddCheckTool(), AddRadioTool(), InsertTool(), DeleteTool(), Realize(), SetDropdownMenu()

## ◆ AddTool() [2/3]

wxToolBarToolBase * wxToolBar::AddTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | wxItemKind | kind = `wxITEM_NORMAL`
| ) |  |

Adds a tool to the toolbar.

This most commonly used version has fewer parameters than the full version below which specifies the more rarely used button features.

Parameters

  toolId | An integer by which the tool may be identified in subsequent operations.
  label | The string to be displayed with the tool. This string may include mnemonics, i.e. characters prefixed by an ampersand ("&"), but they are stripped from it and not actually shown in the toolbar as tools can't be activated from keyboard.
  bitmap | The primary tool bitmap.
  shortHelp | This string is used for the tools tooltip.
  kind | May be wxITEM_NORMAL for a normal button (default), wxITEM_CHECK for a checkable tool (such tool stays pressed after it had been toggled) or wxITEM_RADIO for a checkable tool which makes part of a radio group of tools each of which is automatically unchecked whenever another button in the group is checked. wxITEM_DROPDOWN specifies that a drop-down menu button will appear next to the tool button (only GTK+ and MSW). Call SetDropdownMenu() afterwards.

Remarks
  After you have added tools to a toolbar, you must call Realize() in order to have the tools appear.

See also
  AddSeparator(), AddCheckTool(), AddRadioTool(), InsertTool(), DeleteTool(), Realize(), SetDropdownMenu()

## ◆ AddTool() [3/3]

virtual wxToolBarToolBase * wxToolBar::AddTool | ( | wxToolBarToolBase * | tool | ) |
| virtual

Adds a tool to the toolbar.

Parameters

  tool | The tool to be added.

Remarks
  After you have added tools to a toolbar, you must call Realize() in order to have the tools appear.

See also
  AddSeparator(), AddCheckTool(), AddRadioTool(), InsertTool(), DeleteTool(), Realize(), SetDropdownMenu()

## ◆ ClearTools()

virtual void wxToolBar::ClearTools | ( |  | ) |
| virtual

Deletes all the tools in the toolbar.

## ◆ CreateSeparator()

wxToolBarToolBase * wxToolBar::CreateSeparator | ( |  | ) |

Factory function to create a new separator toolbar tool.

## ◆ CreateTool() [1/2]

virtual wxToolBarToolBase * wxToolBar::CreateTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bmpNormal,
|  | const wxBitmap & | bmpDisabled = `wxNullBitmap`,
|  | wxItemKind | kind = `wxITEM_NORMAL`,
|  | wxObject * | clientData = `NULL`,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | const wxString & | longHelp = `wxEmptyString`
| ) |  |
| virtual

Factory function to create a new toolbar tool.

## ◆ CreateTool() [2/2]

virtual wxToolBarToolBase * wxToolBar::CreateTool | ( | wxControl * | control,
|  | const wxString & | label
| ) |  |
| virtual

Factory function to create a new control toolbar tool.

## ◆ DeleteTool()

virtual bool wxToolBar::DeleteTool | ( | int | toolId | ) |
| virtual

Removes the specified tool from the toolbar and deletes it.

If you don't want to delete the tool, but just to remove it from the toolbar (to possibly add it back later), you may use RemoveTool() instead.

Note
  It is unnecessary to call Realize() for the change to take place, it will happen immediately.

Returns
  true if the tool was deleted, false otherwise.

See also
  DeleteToolByPos()

## ◆ DeleteToolByPos()

virtual bool wxToolBar::DeleteToolByPos | ( | size_t | pos | ) |
| virtual

This function behaves like DeleteTool() but it deletes the tool at the specified position and not the one with the given id.

## ◆ EnableTool()

virtual void wxToolBar::EnableTool | ( | int | toolId,
|  | bool | enable
| ) |  |
| virtual

Enables or disables the tool.

Parameters

  toolId | ID of the tool to enable or disable, as passed to AddTool().
  enable | If true, enables the tool, otherwise disables it.

Remarks
  Some implementations will change the visible state of the tool to indicate that it is disabled.

See also
  GetToolEnabled(), ToggleTool()

## ◆ FindById()

wxToolBarToolBase * wxToolBar::FindById | ( | int | id | ) | const

Returns a pointer to the tool identified by id or NULL if no corresponding tool is found.

## ◆ FindControl()

virtual wxControl * wxToolBar::FindControl | ( | int | id | ) |
| virtual

Returns a pointer to the control identified by id or NULL if no corresponding control is found.

## ◆ FindToolForPosition()

virtual wxToolBarToolBase * wxToolBar::FindToolForPosition | ( | wxCoord | x,
|  | wxCoord | y
| ) |  | const
| virtual

Finds a tool for the given mouse position.

Parameters

  x | X position.
  y | Y position.

Returns
  A pointer to a tool if a tool is found, or NULL otherwise.

Remarks
  Currently not implemented in wxGTK (always returns NULL there).

## ◆ GetMargins()

wxSize wxToolBar::GetMargins | ( |  | ) | const

Returns the left/right and top/bottom margins, which are also used for inter-toolspacing.

See also
  SetMargins()

## ◆ GetToolBitmapSize()

virtual wxSize wxToolBar::GetToolBitmapSize | ( |  | ) | const
| virtual

Returns the size of bitmap that the toolbar expects to have.

The default bitmap size is platform-dependent: for example, it is 16*15 for MSW and 24*24 for GTK. This size does not necessarily indicate the best size to use for the toolbars on the given platform, for this you should use `wxArtProvider::GetNativeSizeHint(wxART_TOOLBAR)` but in any case, as the bitmap size is deduced automatically from the size of the bitmaps associated with the tools added to the toolbar, it is usually unnecessary to call SetToolBitmapSize() explicitly.

Remarks
  Note that this is the size of the bitmap you pass to AddTool(), and not the eventual size of the tool button.

See also
  SetToolBitmapSize(), GetToolSize()

## ◆ GetToolByPos() [1/2]

wxToolBarToolBase * wxToolBar::GetToolByPos | ( | int | pos | ) |

Returns a pointer to the tool at ordinal position pos.

Don't confuse this with FindToolForPosition().

Since
  2.9.1

See also
  GetToolsCount()

## ◆ GetToolByPos() [2/2]

const wxToolBarToolBase * wxToolBar::GetToolByPos | ( | int | pos | ) | const

## ◆ GetToolClientData()

virtual wxObject * wxToolBar::GetToolClientData | ( | int | toolId | ) | const
| virtual

Get any client data associated with the tool.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().

Returns
  Client data, or NULL if there is none.

## ◆ GetToolEnabled()

virtual bool wxToolBar::GetToolEnabled | ( | int | toolId | ) | const
| virtual

Called to determine whether a tool is enabled (responds to user input).

Parameters

  toolId | ID of the tool in question, as passed to AddTool().

Returns
  true if the tool is enabled, false otherwise.

See also
  EnableTool()

## ◆ GetToolLongHelp()

virtual wxString wxToolBar::GetToolLongHelp | ( | int | toolId | ) | const
| virtual

Returns the long help for the given tool.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().

See also
  SetToolLongHelp(), SetToolShortHelp()

## ◆ GetToolPacking()

virtual int wxToolBar::GetToolPacking | ( |  | ) | const
| virtual

Returns the value used for packing tools.

See also
  SetToolPacking()

## ◆ GetToolPos()

virtual int wxToolBar::GetToolPos | ( | int | toolId | ) | const
| virtual

Returns the tool position in the toolbar, or `wxNOT_FOUND` if the tool is not found.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().

## ◆ GetToolsCount()

size_t wxToolBar::GetToolsCount | ( |  | ) | const

Returns the number of tools in the toolbar.

## ◆ GetToolSeparation()

virtual int wxToolBar::GetToolSeparation | ( |  | ) | const
| virtual

Returns the default separator size.

See also
  SetToolSeparation()

## ◆ GetToolShortHelp()

virtual wxString wxToolBar::GetToolShortHelp | ( | int | toolId | ) | const
| virtual

Returns the short help for the given tool.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().

See also
  GetToolLongHelp(), SetToolShortHelp()

## ◆ GetToolSize()

virtual wxSize wxToolBar::GetToolSize | ( |  | ) | const
| virtual

Returns the size of a whole button, which is usually larger than a tool bitmap because of added 3D effects.

See also
  SetToolBitmapSize(), GetToolBitmapSize()

## ◆ GetToolState()

virtual bool wxToolBar::GetToolState | ( | int | toolId | ) | const
| virtual

Gets the on/off state of a toggle tool.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().

Returns
  true if the tool is toggled on, false otherwise.

See also
  ToggleTool()

## ◆ InsertControl()

virtual wxToolBarToolBase * wxToolBar::InsertControl | ( | size_t | pos,
|  | wxControl * | control,
|  | const wxString & | label = `wxEmptyString`
| ) |  |
| virtual

Inserts the control into the toolbar at the given position.

You must call Realize() for the change to take place.

See also
  AddControl(), InsertTool()

## ◆ InsertSeparator()

virtual wxToolBarToolBase * wxToolBar::InsertSeparator | ( | size_t | pos | ) |
| virtual

Inserts the separator into the toolbar at the given position.

You must call Realize() for the change to take place.

See also
  AddSeparator(), InsertTool()

## ◆ InsertStretchableSpace()

wxToolBarToolBase * wxToolBar::InsertStretchableSpace | ( | size_t | pos | ) |

Inserts a stretchable space at the given position.

See AddStretchableSpace() for details about stretchable spaces.

See also
  InsertTool(), InsertSeparator()

Since
  2.9.1

## ◆ InsertTool() [1/2]

wxToolBarToolBase * wxToolBar::InsertTool | ( | size_t | pos,
|  | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap,
|  | const wxBitmap & | bmpDisabled = `wxNullBitmap`,
|  | wxItemKind | kind = `wxITEM_NORMAL`,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | const wxString & | longHelp = `wxEmptyString`,
|  | wxObject * | clientData = `NULL`
| ) |  |

Inserts the tool with the specified attributes into the toolbar at the given position.

You must call Realize() for the change to take place.

See also
  AddTool(), InsertControl(), InsertSeparator()

Returns
  The newly inserted tool or NULL on failure. Notice that with the overload taking tool parameter the caller is responsible for deleting the tool in the latter case.

## ◆ InsertTool() [2/2]

wxToolBarToolBase * wxToolBar::InsertTool | ( | size_t | pos,
|  | wxToolBarToolBase * | tool
| ) |  |

## ◆ OnLeftClick()

virtual bool wxToolBar::OnLeftClick | ( | int | toolId,
|  | bool | toggleDown
| ) |  |
| virtual

Called when the user clicks on a tool with the left mouse button.

This is the old way of detecting tool clicks; although it will still work, you should use the EVT_MENU() or EVT_TOOL() macro instead.

Parameters

  toolId | The identifier passed to AddTool().
  toggleDown | true if the tool is a toggle and the toggle is down, otherwise is false.

Returns
  If the tool is a toggle and this function returns false, the toggle state (internal and visual) will not be changed. This provides a way of specifying that toggle operations are not permitted in some circumstances.

See also
  OnMouseEnter(), OnRightClick()

## ◆ OnMouseEnter()

virtual void wxToolBar::OnMouseEnter | ( | int | toolId | ) |
| virtual

This is called when the mouse cursor moves into a tool or out of the toolbar.

This is the old way of detecting mouse enter events; although it will still work, you should use the EVT_TOOL_ENTER() macro instead.

Parameters

  toolId | Greater than -1 if the mouse cursor has moved into the tool, or -1 if the mouse cursor has moved. The programmer can override this to provide extra information about the tool, such as a short description on the status line.

Remarks
  With some derived toolbar classes, if the mouse moves quickly out of the toolbar, wxWidgets may not be able to detect it. Therefore this function may not always be called when expected.

## ◆ OnRightClick()

virtual void wxToolBar::OnRightClick | ( | int | toolId,
|  | long | x,
|  | long | y
| ) |  |
| virtual

Deprecated:
  This is the old way of detecting tool right clicks; although it will still work, you should use the EVT_TOOL_RCLICKED() macro instead.

Called when the user clicks on a tool with the right mouse button. The programmer should override this function to detect right tool clicks.

Parameters

  toolId | The identifier passed to AddTool().
  x | The x position of the mouse cursor.
  y | The y position of the mouse cursor.

Remarks
  A typical use of this member might be to pop up a menu.

See also
  OnMouseEnter(), OnLeftClick()

## ◆ Realize()

virtual bool wxToolBar::Realize | ( |  | ) |
| virtual

This function should be called after you have added tools.

## ◆ RemoveTool()

virtual wxToolBarToolBase * wxToolBar::RemoveTool | ( | int | id | ) |
| virtual

Removes the given tool from the toolbar but doesn't delete it.

This allows inserting/adding this tool back to this (or another) toolbar later.

Note
  It is unnecessary to call Realize() for the change to take place, it will happen immediately.

See also
  DeleteTool()

## ◆ SetDropdownMenu()

bool wxToolBar::SetDropdownMenu | ( | int | id,
|  | wxMenu * | menu
| ) |  |

Sets the dropdown menu for the tool given by its id.

The tool itself will delete the menu when it's no longer needed. Only supported under GTK+ und MSW.

If you define a EVT_TOOL_DROPDOWN() handler in your program, you must call wxEvent::Skip() from it or the menu won't be displayed.

## ◆ SetMargins() [1/2]

void wxToolBar::SetMargins | ( | const wxSize & | size | ) |

Set the margins for the toolbar.

Parameters

  size | Margin size.

Remarks
  This must be called before the tools are added if absolute positioning is to be used, and the default (zero-size) margins are to be overridden.

See also
  GetMargins(), wxSize

## ◆ SetMargins() [2/2]

virtual void wxToolBar::SetMargins | ( | int | x,
|  | int | y
| ) |  |
| virtual

Set the values to be used as margins for the toolbar.

Parameters

  x | Left margin, right margin and inter-tool separation value.
  y | Top margin, bottom margin and inter-tool separation value.

Remarks
  This must be called before the tools are added if absolute positioning is to be used, and the default (zero-size) margins are to be overridden.

See also
  GetMargins()

## ◆ SetToolBitmapSize()

virtual void wxToolBar::SetToolBitmapSize | ( | const wxSize & | size | ) |
| virtual

Sets the default size of each tool bitmap.

The default bitmap size is 16 by 15 pixels.

Parameters

  size | The size of the bitmaps in the toolbar.

Remarks
  This should be called to tell the toolbar what the tool bitmap size is. Call it before you add tools.

See also
  GetToolBitmapSize(), GetToolSize()

## ◆ SetToolClientData()

virtual void wxToolBar::SetToolClientData | ( | int | id,
|  | wxObject * | clientData
| ) |  |
| virtual

Sets the client data associated with the tool.

Parameters

  id | ID of the tool in question, as passed to AddTool().
  clientData | The client data to use.

## ◆ SetToolDisabledBitmap()

virtual void wxToolBar::SetToolDisabledBitmap | ( | int | id,
|  | const wxBitmap & | bitmap
| ) |  |
| virtual

Sets the bitmap to be used by the tool with the given ID when the tool is in a disabled state.

This can only be used on Button tools, not controls.

Parameters

  id | ID of the tool in question, as passed to AddTool().
  bitmap | Bitmap to use for disabled tools.

Note
  The native toolbar classes on the main platforms all synthesize the disabled bitmap from the normal bitmap, so this function will have no effect on those platforms.

## ◆ SetToolLongHelp()

virtual void wxToolBar::SetToolLongHelp | ( | int | toolId,
|  | const wxString & | helpString
| ) |  |
| virtual

Sets the long help for the given tool.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().
  helpString | A string for the long help.

Remarks
  You might use the long help for displaying the tool purpose on the status line.

See also
  GetToolLongHelp(), SetToolShortHelp(),

## ◆ SetToolNormalBitmap()

virtual void wxToolBar::SetToolNormalBitmap | ( | int | id,
|  | const wxBitmap & | bitmap
| ) |  |
| virtual

Sets the bitmap to be used by the tool with the given ID.

This can only be used on Button tools, not controls.

Parameters

  id | ID of the tool in question, as passed to AddTool().
  bitmap | Bitmap to use for normals tools.

## ◆ SetToolPacking()

virtual void wxToolBar::SetToolPacking | ( | int | packing | ) |
| virtual

Sets the value used for spacing tools.

The default value is 1.

Parameters

  packing | The value for packing.

Remarks
  The packing is used for spacing in the vertical direction if the toolbar is horizontal, and for spacing in the horizontal direction if the toolbar is vertical.

See also
  GetToolPacking()

## ◆ SetToolSeparation()

virtual void wxToolBar::SetToolSeparation | ( | int | separation | ) |
| virtual

Sets the default separator size.

The default value is 5.

Parameters

  separation | The separator size.

See also
  AddSeparator()

## ◆ SetToolShortHelp()

virtual void wxToolBar::SetToolShortHelp | ( | int | toolId,
|  | const wxString & | helpString
| ) |  |
| virtual

Sets the short help for the given tool.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().
  helpString | The string for the short help.

Remarks
  An application might use short help for identifying the tool purpose in a tooltip.

See also
  GetToolShortHelp(), SetToolLongHelp()

## ◆ ToggleTool()

virtual void wxToolBar::ToggleTool | ( | int | toolId,
|  | bool | toggle
| ) |  |
| virtual

Toggles a tool on or off.

This does not cause any event to get emitted.

Parameters

  toolId | ID of the tool in question, as passed to AddTool().
  toggle | If true, toggles the tool on, otherwise toggles it off.

Remarks
  Only applies to a tool that has been specified as a toggle tool.